/*
  labcomm_pragma.h -- user interface for handling labcomm pragma packets.

  Copyright 2014 Sven Gestegård Robertz <sven.robertz@cs.lth.se>
                 Anders Blomdell <anders.blomdell@control.lth.se>

  This file is part of LabComm.

  LabComm is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  LabComm is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _LABCOMM_PRAGMA_H
#define _LABCOMM_PRAGMA_H

typedef int (*labcomm_pragma_handler_callback)(
  struct labcomm_decoder *decoder,
  struct labcomm_decoder *registry,
  char *pragma_type,
  void *context);

typedef labcomm_pragma_handler_callback (*labcomm_pragma_handler_lookup)(
  char *pragma_type,
  struct labcomm_decoder *d,
  void *context);

void labcomm_decoder_register_pragma_handler_lookup(struct labcomm_decoder *d,
		labcomm_pragma_handler_lookup pragma_lookup,
		void *context);

/*XXX TODO: rename to _callback? */
void labcomm_decoder_register_pragma_handler(struct labcomm_decoder *d,
		labcomm_pragma_handler_callback pragma_dispatcher,
		void *context);

/*XXX TODO: rename to _callback? */
int default_pragma_handler(struct labcomm_decoder *d,
		           struct labcomm_decoder *registry,
		           char *pragma_type,
			   void *context);

labcomm_pragma_handler_callback default_pragma_handler_lookup(
                                        char *pragma_type,
                                        struct labcomm_decoder *d,
                                        void *context);

struct labcomm_encoder *labcomm_pragma_builder_new(
                                   struct labcomm_encoder *e,
				   char * pragma_type) ;
int labcomm_pragma_send(struct labcomm_encoder* e);

#endif
